#ifndef CoCoA_GMPAllocator_H
#define CoCoA_GMPAllocator_H

//   Copyright (c)  2005,2006  John Abbott

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License (version 2)
//   as published by the Free Software Foundation.  A copy of the full
//   licence may be found in the file COPYING in this directory.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoA; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include "CoCoA/MemPool.H"

#include <stddef.h>

extern "C"
{
  void* CoCoA_GMP_alloc(size_t sz);
  void* CoCoA_GMP_realloc(void* ptr, size_t oldsz, size_t newsz);
  void CoCoA_GMP_free(void* ptr, size_t sz);
}

namespace CoCoA
{

  class GMPAllocator
  {
  public:
    explicit GMPAllocator(size_t SliceSize=16); // default slice size is 16 bytes
    ~GMPAllocator();
  private: // disable copy ctor and assignment
    GMPAllocator(const GMPAllocator&);           // NEVER DEFINED -- disable default copy ctor
    GMPAllocator& operator=(const GMPAllocator&);// NEVER DEFINED -- disable assignment
  private:
    mutable MemPool myMemPool;
  };

} // end of namespace CoCoA


// RCS header/log in the next few lines
// $Header: /Volumes/Home/cocoa/cvs-repository/CoCoALib-0.99/include/CoCoA/GMPAllocator.H,v 1.1.1.1 2007/03/09 15:16:11 abbott Exp $
// $Log: GMPAllocator.H,v $
// Revision 1.1.1.1  2007/03/09 15:16:11  abbott
// Imported files
//
// Revision 1.5  2006/12/06 17:11:16  cocoa
// -- removed #include "config.H"
//
// Revision 1.4  2006/10/06 14:04:16  cocoa
// Corrected position of #ifndef in header files.
// Separated CoCoA_ASSERT into assert.H from config.H;
// many minor consequential changes (have to #include assert.H).
// A little tidying of #include directives (esp. in Max's code).
//
// Revision 1.3  2006/10/06 10:08:17  cocoa
// Added changelog.
//


#endif
