//   Copyright (c)  2006  John Abbott

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License (version 2)
//   as published by the Free Software Foundation.  A copy of the full
//   licence may be found in the file COPYING in this directory.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoA; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include "CoCoA/bool3.H"
#include "CoCoA/OpenMath.H"

#include <iostream>
using std::ostream;

namespace CoCoA
{

  std::ostream& operator<<(std::ostream& out, bool3 flag)
  {
    if (IsDefinitelyFalse(flag)) return out << "bool3::DefinitelyFalse";
    if (IsDefinitelyTrue(flag)) return out << "bool3::DefinitelyTrue";
    return out << "bool3::uncertain";
  }


  OpenMathOutput& operator<<(OpenMathOutput& out, bool3 flag)
  {
    if (IsDefinitelyFalse(flag)) return out << OpenMathSymbol("logic3", "DefinitelyFalse");
    if (IsDefinitelyTrue(flag)) return out << OpenMathSymbol("logic3", "DefinitelyTrue");
    return out << OpenMathSymbol("logic3", "uncertain");
  }

} // end of namespace CoCoA



// RCS header/log in the next few lines
// $Header: /Volumes/Home/cocoa/cvs-repository/CoCoALib-0.99/src/AlgebraicCore/bool3.C,v 1.1.1.1 2007/03/09 15:16:11 abbott Exp $
// $Log: bool3.C,v $
// Revision 1.1.1.1  2007/03/09 15:16:11  abbott
// Imported files
//
// Revision 1.2  2006/11/02 13:25:43  cocoa
// Simplification of header files: the OpenMath classes have been renamed.
// Many minor consequential changes.
//
// Revision 1.1.1.1  2006/05/30 11:39:37  cocoa
// Imported files
//
// Revision 1.2  2006/05/12 16:10:58  cocoa
// Added OpenMathFwd.H, and tidied OpenMath.H.
// Many consequential but trivial changes.
//
// Revision 1.1  2006/03/12 21:28:33  cocoa
// Major check in after many changes
//
