#include "CoCoA/BuildInfo.H"
#include "CoCoA/GlobalManager.H"
#include "CoCoA/OpenMathXML.H"
#include "CoCoA/RingFp.H"
#include "CoCoA/ZZ.H"
#include "CoCoA/io.H"

using namespace CoCoA;

#include <iostream>
using std::cin;
using std::cout;
using std::endl;

#define TEST_ASSERT(cond)   do { if (!(cond)) CoCoA::AssertionFailed(#cond, __FILE__, __LINE__); } while(0)


// VERY INCOMPLETE

void program()
{
  GlobalManager CoCoAFoundations;

  OpenMathInput OMIn(new OpenMathInputXML(cin));

  OpenMathTag  tag;

  tag = OMIn->myCurrTag();
  while (tag != OpenMathEOF)
  {
    cout << "Read a tag" << endl;
    tag = OMIn->myCurrTag();
  }
}

// Use main() to handle any uncaught exceptions and warn the user about them.
int main()
{
  try
  {
    program();
    return 0;
  }
  catch (const CoCoA::ErrorInfo& err)
  {
    GlobalErrput() << "***ERROR***  UNCAUGHT CoCoA Error";
    ANNOUNCE(err);
  }
  catch (const std::exception& exc)
  {
    GlobalErrput() << "***ERROR***  UNCAUGHT std::exception: " << exc.what() << endl;
  }
  catch(...)
  {
    GlobalErrput() << "***ERROR***  UNCAUGHT UNKNOWN EXCEPTION" << endl;
  }

  BuildInfo::PrintAll(GlobalErrput());
  return 1;
}
